SystemOrganization addCategory: #SoftwareDesign!
SystemOrganization addCategory: #'SoftwareDesign-Algorithm'!
SystemOrganization addCategory: #'SoftwareDesign-Model'!

PolygonMorph subclass: #SDNavEdge
	instanceVariableNames: 'startNode endNode weights'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SoftwareDesign-Model'!

!SDNavEdge class methodsFor: 'instance creation' stamp: 'GNS 11/18/2012 12:21'!
createFrom: aSource to: aDestination withWeight: aWeight

	| edge |
	
	edge := SDNavEdge new.
	edge from: aSource.
	aSource edges add: edge.
	edge to: aDestination.
	edge weights: aWeight.		
	
	^ edge ! !

!SDNavEdge class methodsFor: 'instance creation' stamp: 'GNS 11/20/2012 16:45'!
newWithStartNode: aStartNode andEndNode: anEndNode withWeight: aWeight

	| anEdge |
	
	anEdge := SDNavEdge new.
	anEdge
		startNode: aStartNode;
		endNode: anEndNode;
		weights: aWeight.
	
	^ anEdge ! !

!SDNavEdge methodsFor: 'drawing' stamp: 'bg 11/20/2012 17:21'!
calculateEdgePointArrayfor: aStartNode and: anEndNode

	| startPoint endPoint xDifference yDifference|
	
	startPoint := aStartNode position.
	endPoint := anEndNode position.
	
	xDifference := startPoint x - endPoint x.
	yDifference := startPoint y - endPoint y.
	(xDifference abs < yDifference abs ) 
		ifTrue:
			[(yDifference < 0) 
			ifTrue: 
				[startPoint := startNode bottomCenter.
				endPoint := endNode topCenter.]
			ifFalse:
				[startPoint := startNode topCenter.
				endPoint := endNode bottomCenter.]] 
		ifFalse: 
			[(xDifference < 0) 
			ifTrue: 
				[startPoint := startNode rightCenter.
				endPoint := endNode leftCenter.]
			ifFalse:
				[startPoint := startNode leftCenter.
				endPoint := endNode rightCenter.]].
		
		^Array with: startPoint with: endPoint
		! !

!SDNavEdge methodsFor: 'drawing' stamp: 'GNS 11/20/2012 17:59'!
defaultFontName

	^ Preferences standardDefaultTextFont familyName! !

!SDNavEdge methodsFor: 'drawing' stamp: 'GNS 11/20/2012 18:00'!
defaultFontSize

	^ 10! !

!SDNavEdge methodsFor: 'drawing' stamp: 'bg 11/20/2012 17:17'!
drawEdgefrom: aStartNode to: anEndNode

	| edgePoints |
	edgePoints := self calculateEdgePointArrayfor: aStartNode and: anEndNode.
	
	self 
		vertices: edgePoints
		color: Color black
		borderWidth: 2
		borderColor: Color black;
		makeForwardArrow;
		computeBounds.! !

!SDNavEdge methodsFor: 'drawing' stamp: 'GNS 11/20/2012 18:00'!
drawLabelWith: aContent

	| label |
	
	label := StringMorph contents: self weights asString.
	self addMorph: label.
	label
		fontName: self defaultFontName size: self defaultFontSize;
		lock;
		center: self center + 5.
		
	! !

!SDNavEdge methodsFor: 'drawing' stamp: 'bg 11/20/2012 17:27'!
drawYourselfOn: aCanvas

	aCanvas addMorph: self.
	self drawEdgefrom: self startNode to: self endNode.
	self drawLabelWith: self weights asString.! !

!SDNavEdge methodsFor: 'accessing' stamp: 'GNS 11/20/2012 16:38'!
endNode
	"Answer the value of endNode"

	^ endNode! !

!SDNavEdge methodsFor: 'accessing' stamp: 'GNS 11/20/2012 16:38'!
endNode: anObject
	"Set the value of endNode"

	endNode := anObject! !

!SDNavEdge methodsFor: 'accessing' stamp: 'GNS 11/20/2012 16:38'!
startNode
	"Answer the value of startNode"

	^ startNode! !

!SDNavEdge methodsFor: 'accessing' stamp: 'GNS 11/20/2012 16:38'!
startNode: anObject
	"Set the value of startNode"

	startNode := anObject! !

!SDNavEdge methodsFor: 'accessing' stamp: 'GNS 11/18/2012 12:20'!
weights
	"Answer the copy of the weights"

	^ weights! !

!SDNavEdge methodsFor: 'accessing' stamp: 'GNS 11/18/2012 11:52'!
weights: anObject
	"Set the value of weights"

	weights := anObject! !

Morph subclass: #SDNavGraphCanvas
	instanceVariableNames: 'graph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SoftwareDesign'!

!SDNavGraphCanvas methodsFor: 'as yet unclassified' stamp: 'bg 11/21/2012 00:44'!
deselect

	self graph deselectAllNodes.! !

!SDNavGraphCanvas methodsFor: 'accessing' stamp: 'bg 11/21/2012 00:28'!
graph
	"Answer the value of graph"

	^ graph! !

!SDNavGraphCanvas methodsFor: 'accessing' stamp: 'bg 11/21/2012 00:44'!
graph: anObject
	"Set the value of graph"
	graph := anObject! !

!SDNavGraphCanvas methodsFor: 'accessing' stamp: 'bg 11/21/2012 00:43'!
initialize

	super initialize.
	self on: #click send: #value to: [self deselect].
! !

SystemWindow subclass: #SDNavMainWindow
	instanceVariableNames: 'graph graphCanvas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SoftwareDesign'!

!SDNavMainWindow methodsFor: 'accessing' stamp: 'GNS 11/20/2012 01:10'!
graph
	"Answer the value of graph"

	^ graph! !

!SDNavMainWindow methodsFor: 'accessing' stamp: 'GNS 11/20/2012 01:10'!
graph: anObject
	"Set the value of graph"

	graph := anObject! !

!SDNavMainWindow methodsFor: 'accessing' stamp: 'GNS 11/20/2012 01:10'!
graphCanvas
	"Answer the value of graphCanvas"

	^ graphCanvas! !

!SDNavMainWindow methodsFor: 'accessing' stamp: 'GNS 11/20/2012 01:10'!
graphCanvas: anObject
	"Set the value of graphCanvas"

	graphCanvas := anObject! !

!SDNavMainWindow methodsFor: 'initialization' stamp: 'GNS 11/20/2012 00:09'!
initialize	
	
	super initialize.
	
	self initializeAppearance.
	  
	
	
	
	
	! !

!SDNavMainWindow methodsFor: 'initialization' stamp: 'GNS 11/20/2012 01:09'!
initializeAppearance

	self setLabel: 'Navigation System';
		model: Model new;
		initializeGraphCanvas;
		initializeControlPanel.! !

!SDNavMainWindow methodsFor: 'initialization' stamp: 'bg 11/20/2012 23:56'!
initializeControlPanel

	| controlPanel |
	
	controlPanel := Morph new.
	self addMorph: controlPanel fullFrame: (LayoutFrame fractions: (0@0 corner: 1@0) offsets: (0@0 corner: 0@50)).
	controlPanel color: Color lightGreen.
	
	self
		initializeSimpleMapLoadButton: controlPanel;
		initializeRunDijkstraButton: controlPanel;
		initializeStartEndButton: controlPanel.
	 ! !

!SDNavMainWindow methodsFor: 'initialization' stamp: 'bg 11/21/2012 00:46'!
initializeGraphCanvas

	| graphCanvas |
	
	graphCanvas := SDNavGraphCanvas new.
	self addMorph: graphCanvas fullFrame: (LayoutFrame fractions: (0@0 corner: 1@1) offsets: (0@50 corner: 0@0)).
	graphCanvas color: Color lightGray.
	graphCanvas lock.
	
	self graphCanvas: graphCanvas.! !

!SDNavMainWindow methodsFor: 'initialization' stamp: 'GNS 11/20/2012 18:12'!
initializeRunDijkstraButton: aControlPanel

	| runDijkstraButton |
	
	runDijkstraButton := self makeButton: 'Run Dijkstra' withAction: #runDijkstra andState: nil onControlPanel: aControlPanel.
	runDijkstraButton center: 130 @ (aControlPanel height / 2).
	
	aControlPanel addMorph: runDijkstraButton.! !

!SDNavMainWindow methodsFor: 'initialization' stamp: 'GNS 11/20/2012 18:12'!
initializeSimpleMapLoadButton: aControlPanel

	| loadButton |
	
	loadButton := self makeButton: 'Load' withAction: #loadSimpleMap andState: nil onControlPanel: aControlPanel.
	loadButton center: 30 @ (aControlPanel height / 2).
	
	aControlPanel addMorph: loadButton.! !

!SDNavMainWindow methodsFor: 'initialization' stamp: 'bg 11/21/2012 00:20'!
initializeStartEndButton: aControlPanel

	| button |
	
	button := self makeButton: 'Set as Start Point' withAction: #setStart andState: nil onControlPanel: aControlPanel.
	button center: 260 @ (aControlPanel height / 2).
	
	aControlPanel addMorph: button.
	
	button := self makeButton: 'Set as End Point' withAction: #setEnd andState: nil onControlPanel: aControlPanel.
	button center: 380 @ (aControlPanel height / 2).
	
	aControlPanel addMorph: button.! !

!SDNavMainWindow methodsFor: 'action-handling' stamp: 'bg 11/21/2012 00:36'!
loadSimpleMap

	self graph: SDNavLittleSampleGraph new.
	self graph drawYourselfOn: self graphCanvas.
	self graphCanvas graph: self graph.
! !

!SDNavMainWindow methodsFor: 'initialization' stamp: 'GNS 11/20/2012 18:11'!
makeButton: aLabel withAction: anActionSymbol andState: aStateSymbol onControlPanel: aControlPanel
	
	| button |
	
	button := SimpleButtonMorph new.
   	button
		target: self;
		label: aLabel;
		actionSelector: anActionSymbol.
		
	^ button! !

!SDNavMainWindow methodsFor: 'action-handling' stamp: 'GNS 11/24/2012 01:28'!
runDijkstra

	| algorithm |
	
	algorithm := SDNavDijkstraAlgorithm on: self graph from: nil to: nil.

	"Checken ob ein graph gesetzt ist"
	algorithm step.! !

!SDNavMainWindow methodsFor: 'initialization' stamp: 'bg 11/21/2012 00:01'!
setEnd

	self graph setSelectedAsEnd.! !

!SDNavMainWindow methodsFor: 'initialization' stamp: 'bg 11/21/2012 00:01'!
setStart

	self graph setSelectedAsStart.! !

TestCase subclass: #SDNavDijkstraAlgorithmTestCase
	instanceVariableNames: 'startNode endNode graph distances visitedNodes unvisitedNodes predecessors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SoftwareDesign-Algorithm'!

!SDNavDijkstraAlgorithmTestCase methodsFor: 'tests' stamp: 'GNS 11/24/2012 02:18'!
testCorrectAlgorithmImplementation

	| plainAlgo steppedAlgo testGraph |
	
	testGraph := SDNavLittleSampleGraph new.

	plainAlgo := SDNavDijkstraAlgorithm new.
	plainAlgo
		initRouteFrom: testGraph nodes first to: nil;
		execute.
	
	steppedAlgo := SDNavDijkstraAlgorithm new.
	steppedAlgo initRouteFrom: testGraph nodes first to: nil.
	1 to: 20 do: [:i | steppedAlgo step].
	
	
	self
		should: [plainAlgo startNode = steppedAlgo startNode];
		should: [plainAlgo endNode = steppedAlgo endNode];
		should: [plainAlgo distances = steppedAlgo distances];
		should: [plainAlgo visitedNodes = steppedAlgo visitedNodes];
		should: [plainAlgo unvisitedNodes = steppedAlgo unvisitedNodes];
		should: [plainAlgo predecessors = steppedAlgo predecessors].! !

!SDNavDijkstraAlgorithmTestCase methodsFor: 'tests' stamp: 'GNS 11/24/2012 02:28'!
testPlainAlgoVsSteppedAlgo

	| plainAlgo steppedAlgo testGraph |
	
	testGraph := SDNavLittleSampleGraph new.

	plainAlgo := SDNavDijkstraAlgorithm new.
	plainAlgo
		initRouteFrom: testGraph nodes first to: nil;
		execute.
	
	steppedAlgo := SDNavDijkstraAlgorithm new.
	steppedAlgo initRouteFrom: testGraph nodes first to: nil.
	1 to: 20 do: [:i | steppedAlgo step].
	
	
	self
		should: [plainAlgo startNode = steppedAlgo startNode];
		should: [plainAlgo endNode = steppedAlgo endNode];
		should: [plainAlgo distances = steppedAlgo distances];
		should: [plainAlgo visitedNodes = steppedAlgo visitedNodes];
		should: [plainAlgo unvisitedNodes = steppedAlgo unvisitedNodes];
		should: [plainAlgo predecessors = steppedAlgo predecessors].! !

Object subclass: #SDNavAlgorithm
	instanceVariableNames: 'stepMethod'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SoftwareDesign-Algorithm'!

!SDNavAlgorithm methodsFor: 'algorithm-stepping' stamp: 'GNS 11/24/2012 02:23'!
doingNothing

	"Really doing nothing."! !

!SDNavAlgorithm methodsFor: 'algorithm-stepping' stamp: 'GNS 11/24/2012 02:20'!
firstStep
	
	self subclassResponsibility.! !

!SDNavAlgorithm methodsFor: 'initialization' stamp: 'GNS 11/24/2012 02:27'!
initialize
	
	super initialize.
	
	self stepMethod: self firstStep.! !

!SDNavAlgorithm methodsFor: 'algorithm-stepping' stamp: 'GNS 11/24/2012 02:22'!
lastStep
	
	self stepMethod: [self doingNothing.].! !

!SDNavAlgorithm methodsFor: 'algorithm-stepping' stamp: 'GNS 11/24/2012 02:23'!
nextStep: aMethodBlock
	
	"The short form for stepMethod:."
	self stepMethod: aMethodBlock.! !

!SDNavAlgorithm methodsFor: 'algorithm-stepping' stamp: 'GNS 11/22/2012 02:29'!
step

	self stepMethod value! !

!SDNavAlgorithm methodsFor: 'accessing' stamp: 'GNS 11/21/2012 10:48'!
stepMethod
	"Answer the value of stepMethod"

	^ stepMethod! !

!SDNavAlgorithm methodsFor: 'accessing' stamp: 'GNS 11/24/2012 00:39'!
stepMethod: aMethodBlock
	"Set the value of stepMethod"

	stepMethod := aMethodBlock! !

SDNavAlgorithm subclass: #SDNavDijkstraAlgorithm
	instanceVariableNames: 'startNode endNode graph distances visitedNodes unvisitedNodes predecessors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SoftwareDesign-Algorithm'!

!SDNavDijkstraAlgorithm methodsFor: 'accessing' stamp: 'GNS 11/21/2012 00:35'!
distances
	"Answer the value of distance"
	
	distances ifNil: [
		distances := Dictionary new.].
	
	^ distances! !

!SDNavDijkstraAlgorithm methodsFor: 'accessing' stamp: 'GNS 11/24/2012 00:46'!
endNode
	"Answer the value of endNode"

	^ endNode! !

!SDNavDijkstraAlgorithm methodsFor: 'accessing' stamp: 'GNS 11/24/2012 00:46'!
endNode: anObject
	"Set the value of endNode"

	endNode := anObject! !

!SDNavDijkstraAlgorithm methodsFor: 'algorithm' stamp: 'GNS 11/24/2012 01:24'!
execute

	"Step 1 - start"
	self distances at: self startNode put: 0.
	self unvisitedNodes add: self startNode.
	"Step 1 - end"
	
	"Step 2 - start"
	[self unvisitedNodes size > 0] whileTrue: [ | aNode |
	"Step 2 - end"
		
		"Step 3 - start"	
		aNode := self getMininumOfUnVisitedNodes.
		"Step 3 - end"
		
		"Step 4 - start"
		self visitedNodes add: aNode.
		self unvisitedNodes remove: aNode.
		"Step 4 - end"
		
		"Step 5 - start"
		self findMinimalDistances: aNode.
		"Step 5 - start"
		].
	
	"Step lastStep"! !

!SDNavDijkstraAlgorithm methodsFor: 'algorithm' stamp: 'GNS 11/21/2012 00:35'!
findMinimalDistances: aNode

	| unvisitedNeighbors |
	
	unvisitedNeighbors := self unvisitedNeighborsOf: aNode.
	unvisitedNeighbors do: [ :unvisitedNeighbor |
		
		| tempDistance |
		tempDistance := (self shortestDistanceOf: aNode) + (aNode distanceTo: unvisitedNeighbor).
		
		((self shortestDistanceOf: unvisitedNeighbor) > tempDistance ) ifTrue: [
			self distances at: unvisitedNeighbor put: tempDistance.
			self predecessors at: unvisitedNeighbor put: aNode.
			self unvisitedNodes add: unvisitedNeighbor.].
	].! !

!SDNavDijkstraAlgorithm methodsFor: 'algorithm-stepping' stamp: 'GNS 11/24/2012 02:20'!
firstStep

	^ [self step1]! !

!SDNavDijkstraAlgorithm methodsFor: 'algorithm' stamp: 'GNS 11/21/2012 00:35'!
getMininumOfUnVisitedNodes
	
	| minimum |
	
	minimum := nil.
	
	self unvisitedNodes do: [ :unvisitedNode |
		minimum
			ifNil: [minimum := unvisitedNode.]
			ifNotNil: [
				((self shortestDistanceOf: unvisitedNode)
					< (self shortestDistanceOf: minimum)) ifTrue: [minimum := unvisitedNode.]].	].
	^ minimum! !

!SDNavDijkstraAlgorithm methodsFor: 'accessing' stamp: 'GNS 11/21/2012 00:35'!
graph
	"Answer the value of graph"

	^ graph! !

!SDNavDijkstraAlgorithm methodsFor: 'accessing' stamp: 'GNS 11/21/2012 00:35'!
graph: anObject
	"Set the value of graph"

	graph := anObject! !

!SDNavDijkstraAlgorithm methodsFor: 'initialization' stamp: 'GNS 11/24/2012 01:07'!
initRouteFrom: theStartNode to: theEndNode

	self
		startNode: theStartNode;
		endNode: theEndNode.
	
	! !

!SDNavDijkstraAlgorithm methodsFor: 'algorithm-stepping' stamp: 'GNS 11/24/2012 01:16'!
lastStep
	
	"Do nothing until now."
	Transcript
		show: '---------------------', String cr;
		show: 'Distances ', self distances asString, ' ', String cr;
		show: '---------------------', String cr.! !

!SDNavDijkstraAlgorithm methodsFor: 'accessing' stamp: 'GNS 11/21/2012 00:35'!
predecessors
	"Answer the value of predecessors"

	predecessors ifNil: [
		predecessors := Dictionary new.].
	
	^ predecessors! !

!SDNavDijkstraAlgorithm methodsFor: 'algorithm' stamp: 'GNS 11/21/2012 00:35'!
shortestDistanceOf: aNode
	
	| distance |
	distance := self distances at: aNode ifAbsent: [ ^ 10000].
	^ distance.
	! !

!SDNavDijkstraAlgorithm methodsFor: 'accessing' stamp: 'GNS 11/21/2012 00:35'!
startNode
	"Answer the value of startNode"

	^ startNode! !

!SDNavDijkstraAlgorithm methodsFor: 'accessing' stamp: 'GNS 11/21/2012 00:35'!
startNode: anObject
	"Set the value of startNode"

	startNode := anObject! !

!SDNavDijkstraAlgorithm methodsFor: 'algorithm-stepping' stamp: 'GNS 11/24/2012 02:24'!
step1

	"Step 1"
	self distances at: self startNode put: 0.
	self unvisitedNodes add: self startNode.
	
	self nextStep: [self step2.].! !

!SDNavDijkstraAlgorithm methodsFor: 'algorithm-stepping' stamp: 'GNS 11/24/2012 02:26'!
step2

	"Visualizing what it this if means"
	(self unvisitedNodes size > 0)
		ifTrue: [self nextStep: [self step3.].]
		ifFalse: [self lastStep.].
		! !

!SDNavDijkstraAlgorithm methodsFor: 'algorithm-stepping' stamp: 'GNS 11/24/2012 02:24'!
step3

	"Visualizing what this "
	
	"CloUnvNode means closestUnvisitedNode"
	| cloUnvNode |

	cloUnvNode := nil.
	
	self unvisitedNodes do: [ :unvisitedNode |
		cloUnvNode
			ifNil: [cloUnvNode := unvisitedNode.]
			ifNotNil: [
				((self shortestDistanceOf: unvisitedNode)
					< (self shortestDistanceOf: cloUnvNode)) ifTrue: [cloUnvNode := unvisitedNode.]].	].
	
	
	self nextStep: [self step4: cloUnvNode.].
		! !

!SDNavDijkstraAlgorithm methodsFor: 'algorithm-stepping' stamp: 'GNS 11/24/2012 02:25'!
step4: aNode

	"Visualizing what this "
	Transcript show: 'Step4 - UnvNodes '.self unvisitedNodes asString.
	
	self visitedNodes add: aNode.
	self unvisitedNodes remove: aNode.
	
	
	self nextStep: [self step5: aNode.].
		! !

!SDNavDijkstraAlgorithm methodsFor: 'algorithm-stepping' stamp: 'GNS 11/24/2012 02:25'!
step5: aNode

	"Visualizing what this "
	
	| unvisitedNeighbors |
	
	unvisitedNeighbors := self unvisitedNeighborsOf: aNode.
	unvisitedNeighbors do: [ :unvisitedNeighbor |
		
		| tempDistance |
		tempDistance := (self shortestDistanceOf: aNode) + (aNode distanceTo: unvisitedNeighbor).
		
		((self shortestDistanceOf: unvisitedNeighbor) > tempDistance ) ifTrue: [
			self distances at: unvisitedNeighbor put: tempDistance.
			self predecessors at: unvisitedNeighbor put: aNode.
			self unvisitedNodes add: unvisitedNeighbor.].
	].
	
	self nextStep: [self step2.].
		! !

!SDNavDijkstraAlgorithm methodsFor: 'algorithm' stamp: 'GNS 11/21/2012 00:35'!
unvisitedNeighborsOf: aNode

	| unvisitedNeighbors |
	
	unvisitedNeighbors := OrderedCollection new.
	
	aNode edges do: [ :anEdge |
		
		| destinationNode |
		destinationNode := anEdge endNode.
		
		(self visitedNodes includes: destinationNode) ifFalse: [
			unvisitedNeighbors add: destinationNode.].
		].
	
	^ unvisitedNeighbors  ! !

!SDNavDijkstraAlgorithm methodsFor: 'accessing' stamp: 'GNS 11/21/2012 00:35'!
unvisitedNodes
	"Answer the value of unvisitedNodes"

	unvisitedNodes ifNil: [
		unvisitedNodes := Set new.].
	
	^ unvisitedNodes! !

!SDNavDijkstraAlgorithm methodsFor: 'accessing' stamp: 'GNS 11/21/2012 00:35'!
visitedNodes
	"Answer the value of visitedNodes"

	visitedNodes ifNil: [
		visitedNodes := Set new.].
	
	 ^ visitedNodes! !

SDNavAlgorithm subclass: #SDNavLittleAlgorithm
	instanceVariableNames: 'startNode graph distances visitedNodes unvisitedNodes predecessors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SoftwareDesign-Algorithm'!

!SDNavLittleAlgorithm methodsFor: 'initialization' stamp: 'GNS 11/22/2012 02:30'!
firstStepMethod

	^ [self sayHello]! !

!SDNavLittleAlgorithm methodsFor: 'algorithm-stepping' stamp: 'GNS 11/22/2012 02:27'!
sayHello

	Transcript show: 'Hello'.
	
	self nextStepMethod: [self sayHuhu].! !

!SDNavLittleAlgorithm methodsFor: 'algorithm-stepping' stamp: 'GNS 11/22/2012 02:28'!
sayHuhu

	Transcript show: 'Huhu'.
	
	self nextStepMethod: [self sayHello].! !

Object subclass: #SDNavGraph
	instanceVariableNames: 'nodes myCanvas startNode endNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SoftwareDesign-Model'!

SDNavGraph subclass: #SDNavBerlinSBahnGraph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SoftwareDesign-Model'!

!SDNavBerlinSBahnGraph methodsFor: 'initialization' stamp: 'GNS 11/20/2012 01:16'!
initialize

	super initialize.
	
	self initializeGraphStructure.! !

!SDNavBerlinSBahnGraph methodsFor: 'initialization' stamp: 'GNS 11/20/2012 01:18'!
initializeGraphStructure	
	
	| nodeA nodeB nodeC nodeD nodeE |
	
	nodeA := SDNavNode createWithName: 'NodeA'.
	nodeB := SDNavNode createWithName: 'NodeB'.   
	nodeC := SDNavNode createWithName: 'NodeC'.
	nodeD := SDNavNode createWithName: 'NodeD'.   
	nodeE := SDNavNode createWithName: 'NodeE'.
	
	nodeA addConnectionTo: nodeB withWeight: 1.
	nodeA addConnectionTo: nodeC withWeight: 1.
	nodeC addConnectionTo: nodeD withWeight: 1.
	nodeD addConnectionTo: nodeE withWeight: 1.
	nodeE addConnectionTo: nodeA withWeight: 1.   
	
	self
		addNode: nodeA;
		addNode: nodeB;
		addNode: nodeC;
		addNode: nodeD;
		addNode: nodeE.! !

!SDNavGraph methodsFor: 'accessing' stamp: 'GNS 11/20/2012 00:47'!
addNode: aNode

	self nodes add: aNode.! !

!SDNavGraph methodsFor: 'drawing' stamp: 'bg 11/20/2012 19:55'!
deselectAllNodes

	self nodes do: [:aNode | aNode select: false].! !

!SDNavGraph methodsFor: 'drawing' stamp: 'GNS 11/20/2012 16:49'!
drawEdges

	self nodes do: [ :aNode |
		aNode edges do: [:anEdge |
			anEdge drawYourselfOn: self myCanvas.].
		].
! !

!SDNavGraph methodsFor: 'drawing' stamp: 'bg 11/20/2012 18:32'!
drawNodes

	self nodes do: [ :aNode |
		aNode drawYourselfOn: self myCanvas.].! !

!SDNavGraph methodsFor: 'drawing' stamp: 'GNS 11/20/2012 00:56'!
drawYourselfOn: aMorph

	
	self myCanvas: aMorph;
		drawNodes;
		drawEdges.! !

!SDNavGraph methodsFor: 'accessing' stamp: 'bg 11/21/2012 00:17'!
endNode
	"Answer the value of endNode"

	^ endNode! !

!SDNavGraph methodsFor: 'accessing' stamp: 'bg 11/21/2012 00:17'!
endNode: anObject
	"Set the value of endNode"

	endNode := anObject! !

!SDNavGraph methodsFor: 'initialization' stamp: 'GNS 11/20/2012 00:39'!
initialize

	super initialize.! !

!SDNavGraph methodsFor: 'accessing' stamp: 'GNS 11/20/2012 00:56'!
myCanvas
	"Answer the value of myCanvas"

	^ myCanvas! !

!SDNavGraph methodsFor: 'accessing' stamp: 'GNS 11/20/2012 00:56'!
myCanvas: anObject
	"Set the value of myCanvas"

	myCanvas := anObject! !

!SDNavGraph methodsFor: 'accessing' stamp: 'GNS 11/18/2012 15:43'!
nodes
	
	nodes ifNil: [
		nodes := OrderedCollection new.].
	
	^ nodes! !

!SDNavGraph methodsFor: 'accessing' stamp: 'GNS 11/20/2012 00:56'!
nodes: anObject
	"Set the value of nodes"

	nodes := anObject! !

!SDNavGraph methodsFor: 'accessing' stamp: 'bg 11/21/2012 00:18'!
setSelectedAsEnd

	self nodes do: [:aNode | 
		aNode isSelected 
		ifTrue:[
			aNode color: Color red.
			self endNode: aNode.]
		ifFalse:[
			(self startNode = aNode) 
			ifFalse:[
				aNode color: Color white.
				]]]! !

!SDNavGraph methodsFor: 'accessing' stamp: 'bg 11/21/2012 00:17'!
setSelectedAsStart

	self nodes do: [:aNode | 
		aNode isSelected 
		ifTrue:[
			aNode color: Color green.
			self startNode: aNode.]
		ifFalse:[
			(self endNode = aNode) 
			ifFalse:[
				aNode color: Color white.
				]]]! !

!SDNavGraph methodsFor: 'accessing' stamp: 'bg 11/21/2012 00:17'!
startNode
	"Answer the value of startNode"

	^ startNode! !

!SDNavGraph methodsFor: 'accessing' stamp: 'bg 11/21/2012 00:17'!
startNode: anObject
	"Set the value of startNode"

	startNode := anObject! !

SDNavGraph subclass: #SDNavLittleSampleGraph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SoftwareDesign-Model'!

!SDNavLittleSampleGraph methodsFor: 'initialization' stamp: 'GNS 11/20/2012 00:38'!
initialize

	super initialize.
	
	self initializeGraphStructure.! !

!SDNavLittleSampleGraph methodsFor: 'initialization' stamp: 'bg 11/20/2012 23:10'!
initializeGraphStructure
	
	| nodeA nodeB nodeC |
	
	nodeA := SDNavNode createWithName: 'A' on: 3@5 in: self.
	nodeB := SDNavNode createWithName: 'B' on: 4@2 in: self.   
	nodeC := SDNavNode createWithName: 'C' on: 3@3 in: self.
	
	nodeA addConnectionTo: nodeB withWeight: 2.
	nodeA addConnectionTo: nodeC withWeight: 5.
	nodeB addConnectionTo: nodeC withWeight: 2.
	   
	
	self
		addNode: nodeA;
		addNode: nodeB;
		addNode: nodeC.
	
	! !

Object subclass: #SDNavGraphRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SoftwareDesign'!

!SDNavGraphRenderer class methodsFor: 'as yet unclassified' stamp: 'GNS 11/20/2012 00:45'!
drawEdges

	self nodes do: [ :node |
		self drawEdgesFor: node.].! !

!SDNavGraphRenderer class methodsFor: 'as yet unclassified' stamp: 'GNS 11/20/2012 00:44'!
drawEdgesFor: aNode

	aNode edges do: [ :edge |
		
		self addMorph: edge.
		
		
		edge vertices: (Array with: (aNode position) with: (edge to position)) color: Color black borderWidth: 2 borderColor: Color black.
		edge makeForwardArrow.
		edge computeBounds.
		].
! !

!SDNavGraphRenderer class methodsFor: 'as yet unclassified' stamp: 'GNS 11/20/2012 00:53'!
drawNodesOf: aGraph on: aMorph
	
	self
		drawNodes.
	
	"aMorph addMorph: aNode. 
	aNode extent: 30@30; 
		position: self position + (aNode gridPosition * 50).
		
	aGraph nodes do: [ :node |
		self drawEdgesFor: node.]."
! !

!SDNavGraphRenderer class methodsFor: 'as yet unclassified' stamp: 'GNS 11/20/2012 00:52'!
render: aGraph on: aMorph
	
	self
		drawNodes.
	
	"aMorph addMorph: aNode. 
	aNode extent: 30@30; 
		position: self position + (aNode gridPosition * 50).
		
	aGraph nodes do: [ :node |
		self drawEdgesFor: node.]."
! !

CircleMorph subclass: #SDNavNode
	instanceVariableNames: 'gridPosition name edges isSelected graph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SoftwareDesign-Model'!

!SDNavNode class methodsFor: 'instance creation' stamp: 'GNS 11/18/2012 15:41'!
createWithName: aName

	| node |
	
	node := SDNavNode new.
	node name: aName.		
	
	^ node ! !

!SDNavNode class methodsFor: 'instance creation' stamp: 'bg 11/20/2012 19:38'!
createWithName: aName on: aPoint

	| node |
	
	node := SDNavNode new.
	node name: aName.	
	node gridPosition: aPoint.
	node on: #click send: #value to: [node toggleSelect].
	
	^ node ! !

!SDNavNode class methodsFor: 'instance creation' stamp: 'bg 11/20/2012 23:07'!
createWithName: aName on: aPoint in: aGraph

	| node |
	
	node := SDNavNode new.
	node name: aName.	
	node gridPosition: aPoint.
	node on: #click send: #value to: [node toggleSelect].
	node graph: aGraph.
	
	
	^ node ! !

!SDNavNode methodsFor: 'accessing' stamp: 'GNS 11/20/2012 16:41'!
addConnectionTo: aNode withWeight: aWeight

	| edge |
	
	edge := SDNavEdge newWithStartNode: self andEndNode: aNode withWeight: aWeight.
	
	self edges add: edge.
	
	^ edge! !

!SDNavNode methodsFor: 'drawing' stamp: 'GNS 11/20/2012 17:57'!
defaultFontName

	^ Preferences standardDefaultTextFont familyName! !

!SDNavNode methodsFor: 'drawing' stamp: 'GNS 11/20/2012 17:58'!
defaultFontSize

	^ 8! !

!SDNavNode methodsFor: 'utilities' stamp: 'bg 11/20/2012 18:47'!
distanceTo: aNode

	
	self edges do: [ :edge |
		(edge endNode = aNode) ifTrue: [^ edge weights ]
		].
	^ 1000! !

!SDNavNode methodsFor: 'drawing' stamp: 'bg 11/20/2012 23:59'!
drawYourselfOn: aCanvas

	| label |
	aCanvas addMorph: self. 
	self
		extent: 30@30; 
		center: aCanvas topLeft + (self gridPosition * 50);
		color: Color white.
		
	label := StringMorph contents: self name.
	self addMorph: label.
	label
		fontName: self defaultFontName size: self defaultFontSize;
		lock;
		center: self center.! !

!SDNavNode methodsFor: 'accessing' stamp: 'GNS 11/18/2012 12:26'!
edges
	"Answer the value of edges"
	
	edges ifNil: [
		edges := OrderedCollection new.].
	
	^ edges! !

!SDNavNode methodsFor: 'accessing' stamp: 'GNS 11/18/2012 16:59'!
edges: anObject
	"Set the value of edges"

	edges := anObject! !

!SDNavNode methodsFor: 'accessing' stamp: 'bg 11/20/2012 23:08'!
graph

	^graph! !

!SDNavNode methodsFor: 'accessing' stamp: 'bg 11/20/2012 23:08'!
graph: aGraph

	graph := aGraph! !

!SDNavNode methodsFor: 'accessing' stamp: 'GNS 11/18/2012 17:13'!
gridPosition
	"Answer the value of gridposition"

	^ gridPosition! !

!SDNavNode methodsFor: 'accessing' stamp: 'GNS 11/18/2012 17:13'!
gridPosition: anObject
	"Set the value of gridposition"

	gridPosition := anObject! !

!SDNavNode methodsFor: 'accessing' stamp: 'bg 11/20/2012 19:45'!
isSelected

	isSelected ifNil: [
		isSelected := false.].
	
	^isSelected.! !

!SDNavNode methodsFor: 'accessing' stamp: 'GNS 11/20/2012 16:18'!
name

	^ name! !

!SDNavNode methodsFor: 'accessing' stamp: 'GNS 11/18/2012 11:54'!
name: anObject
	"Set the value of name"

	name := anObject! !

!SDNavNode methodsFor: 'drawing' stamp: 'bg 11/20/2012 19:52'!
select

	! !

!SDNavNode methodsFor: 'drawing' stamp: 'bg 11/20/2012 23:58'!
select: aBoolean

	aBoolean ifTrue:[
		self graph deselectAllNodes.
		isSelected := true.
		self borderWidth: 4	]
	ifFalse:[
		isSelected := false.
		self borderWidth: 1	].! !

!SDNavNode methodsFor: 'drawing' stamp: 'bg 11/20/2012 19:55'!
toggleSelect

	self isSelected ifFalse:[
		self select: true.]
	ifTrue: [
		self select: false.]! !
